{
Что скрипт умеет: сортирует заказы по коробочкам, может брать заказы из нескольких коробок, может брать их из книг заказов внутри.
Инструкция:
 Надо обустроить коробки для сортировки: ставим в доме как минимум три коробки - для 10, 15 и 20 предметных заказов.
 Каждый подписываем с помощью Container Engraving Tool (крафтится тинкером) соответственно с типом заказов и количеством 
 предметов (BS, Tailor, Alchemy, Bowcraft, Cook, Carpenter, Scribe, Tinker), например BS_15, Alchemy_10 и тд.
 В каждую коробку закидываем по две коробки, одна подписана "exceptional", вторая "non exceptional"
 В каждую из этих коробок закидываем коробки с подписанными на них ресурсами (Названия описаны в файле resources.txt, вам нужно второе название в строке)
 ВНИМАНИЕ! В каждой коробке обязательно должна быть как минимум коробка с надписью default - туда будут попадать все заказы из стандартного ресурса, в 
 случае бс, карпентри\боукрафта и тейлора или вообще все заказы в остальных случаях.
 Далее определяем их айдишники и заносим в конфиг
1) Создайте текстовый файл с названием ИМЯ_ПРОФИЛЯ_BODSorter_Config.txt в Scripts/BODSorter
2) Заполните
bods_At_Once=70               <- сколько заказов брать за раз
top_box_id=$2DF4              <- айдишники коробок с подписями количества предметов
except_box_id=$E3F            <- айдишники коробок с exceptional и non exceptional
resource_box_id=$9A9          <- айдишники коробок с подписями ресурсов
saveTime=120                  <- время ожидания сейва в секундах
not_found_container=$403EBF3F <- серийник коробки, куда пойдут заказы, для которых мы не нашли коробки
ready_deeds_containers=[      
$403EBFFF                     <- серийники коробок с заказами
]                             <- обязательно закрывать скобки на новой строчке
3) Файл конфига, types.txt и resources.txt должны лежать в папке Scripts/BODSorter/
4) Файл BODSorter.cs и CoreSorter.pas должны лежать в папке Scripts/BODSorter/
5) Запускайте!
}
unit CoreSorter;
interface

type
{Используется для определения цвета бода и коробки для него, а также для определения ресурса и коробки для него}
TColorDef = record
Hue:     Cardinal;
BoxName: String;
end;

TBodDef = record
Amt:         Integer;
Exceptional: Boolean;
Res:         String;
TopBox:      TColorDef;
end;

TResDef = record
ResName: String;
BoxName: String;
end;

Const
//DO NOT TOUCH BELOW
//items
book_id             = $2259;
deed_id             = $2258;
//Gumps
bob_gump            = $54f555df;
last_bod_btn        = 6;
procedure CheckConnection;
function HasProperty(item:Cardinal; prop: String):boolean;
function GetProperty(item:Cardinal; prop: Integer):String;
function TotalProperties(item:Cardinal):integer;
function GetPropertyByName(item:Cardinal; prop: String):String;
function GetPropNameByStr(id:Cardinal;str:String): String;
function GetPropByStr(id:Cardinal;str:String): Integer;
procedure LoadBODColors;
procedure WaitSave;
procedure RemoveOldSaveMessages;
procedure LoadConfig;
procedure TrySort;
procedure LoadResNames;
procedure Sort(id:Cardinal);
function GetReadyDeedsContainer():Cardinal;
function GetTopBoxName(id:Cardinal):String;
function FindTopBox(name:String):Cardinal;
function FindResourceBox(name:String; container:Cardinal):Cardinal;
function FindBoxByName(name:String; container:Cardinal):Cardinal;
function BuildBODDef(id:Cardinal): TBODDef;
function GetResourceBoxName(resource:String): String;
function IsNumber(a:string):Boolean;
procedure ReplyGump(id, btn: Cardinal);
function WaitForGump(id:Cardinal): Integer;
procedure CloseGump(id: Cardinal);

implementation
var
ColorDefs: array of TColorDef;
ResDefs: array of TResDef;
saveTime: Integer;
ready_deeds_containers: array of Cardinal;
bods_At_Once: Integer;
except_box_id,resource_box_id,top_box_id, not_found_cont: Cardinal;

function WaitForGump(id:Cardinal): Integer;
var
attempts, i: Integer;
begin
  for attempts := 0 to 15 do begin
    {AddToSystemJournal('Ждем гамп...');}
    wait(200);
    for i := 0 to GetGumpsCount - 1 do begin
      if GetGumpID(i) = id then begin
        Result := i;
        Exit;
      end;
    end;
  end;
  Result := -1;
end;

procedure CloseGump(id: Cardinal);
var
it:Integer;
begin
  for it := 0 to GetGumpsCount - 1 do begin
    if (GetGumpID(it) = id) then begin
      CloseSimpleGump(it);
      Wait(500);
      break;
    end;
  end;
end;

procedure ReplyGump(id, btn: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      if NumGumpButton(i, btn) then begin
        Wait(500);
        break;
      end;
    end;
  end;
end;

function GetReadyDeedsContainer():Cardinal;
var
i, j, cur, max:Integer;
list:TStringList;
str1, tmpStr:String;
begin
  for i := 0 to Length(ready_deeds_containers) - 1 do begin
    str1 := GetProperty(ready_deeds_containers[i], TotalProperties(ready_deeds_containers[i]) - 1);
    list := TStringList.Create;
    StrBreakApart(str1, ',', list);
    str1 := list[0];
    list.Free;
    tmpStr := '';
    cur := -1;
    for j := 1 to Length(str1) do begin
      if(cur = -1) then begin
        if(IsNumber(str1[j])) then begin
          tmpStr := tmpStr + str1[j];
        end;
        if(str1[j] = '/') then begin
          cur := StrToInt(tmpStr);
          tmpStr := '';
        end;
      end else begin
        if(not IsNumber(str1[j])) then begin
          max := StrToInt(tmpStr)
        end else begin
          tmpStr := tmpStr + str1[j];
        end;
      end;
    end;
    //AddToSystemJournal('Container: ' + IntToStr(ready_deeds_containers[i]) + '. Items: ' + IntToStr(cur) + '/' + IntToStr(max));
    if(cur > 0) then begin
      Result:=ready_deeds_containers[i];
      EXIT;
    end;
  end;
end;

function GetTopBoxName(id:Cardinal):String;
var
 i:Integer;
begin
 for i := 0 to Length(ColorDefs) - 1 do begin
	if(GetColor(id) = ColorDefs[i].Hue) then begin
		Result := ColorDefs[i].BoxName;
		EXIT;
	end;
 end;
 AddToSystemJournal('NO name defined for ' + IntToStr(GetColor(id)));
 Halt; 
end;

function FindBoxByName(name:string; container:Cardinal):Cardinal;
var
i, cur, max:Integer;
list, list2:TStringList;
id:Cardinal;
str,str1,tmpStr:String;
begin
  FindDistance := 15;
  FindVertical := 25;
  FindType(except_box_id, container);
  list := TStringList.Create;
  GetFindedList(list);
  for i := 0 to list.Count - 1 do begin
    id := StrToInt('$'+list[i]);
    str := GetPropertyByName(id, 'engraved: '+name);
    if(str <> '') then begin
          Result:=id;
		  list.Free;
          EXIT;
    end;
  end;
  list.Free;
end;

function FindResourceBox(name:string; container:Cardinal):Cardinal;
var
i, cur, max:Integer;
list, list2:TStringList;
id:Cardinal;
str,str1,tmpStr:String;
begin
  FindDistance := 15;
  FindVertical := 25;
  FindType(resource_box_id, container);
  list := TStringList.Create;
  GetFindedList(list);
  for i := 0 to list.Count - 1 do begin
    id := StrToInt('$'+list[i]);
    str := GetPropertyByName(id, 'engraved: '+name);
    if(str <> '') then begin
          Result:=id;
		  list.Free;
          EXIT;
    end;
  end;
  list.Free;
end;

function GetResourceBoxName(resource:String):String;
var
 i:Integer;
begin
  if(length(resource) > 0) then begin
    if((resource[length(resource)] = '.')) then begin
      resource[length(resource)] := ' ';
    end;
  end;
 resource := Trim(resource);
 for i := 0 to Length(ResDefs) - 1 do begin
	if(resource = ResDefs[i].ResName) then begin
		Result := ResDefs[i].BoxName;
		EXIT;
	end;
 end;
 AddToSystemJournal('NO resource name defined for ' + resource);
 Halt; 
end;

function FindTopBox(name:String):Cardinal;
var
i, cur, max,j:Integer;
list, list2:TStringList;
id:Cardinal;
str,str1,tmpStr:String;
begin
  AddToSystemJournal('Searching: ' + name);
  FindDistance := 15;
  FindVertical := 25;
  FindType(top_box_id, Ground);
  list := TStringList.Create;
  GetFindedList(list);
  for i := 0 to list.Count - 1 do begin
    id := StrToInt('$'+list[i]);
    str := GetPropertyByName(id, 'engraved: '+name);
    if(str <> '') then begin
	str1 := GetProperty(id, TotalProperties(id) - 1);
	list2 := TStringList.Create;
    StrBreakApart(str1, ',', list2);
	str1 := list2[0];
	list2.Free;
    tmpStr := '';
    cur := -1;
    for j := 1 to Length(str1) do begin
      if(cur = -1) then begin
        if(IsNumber(str1[j])) then begin
          tmpStr := tmpStr + str1[j];
        end;
        if(str1[j] = '/') then begin
          cur := StrToInt(tmpStr);   
          tmpStr := '';
        end;
      end else begin
        if(not IsNumber(str1[j])) then begin
          max := StrToInt(tmpStr)
        end else begin
           tmpStr := tmpStr + str1[j]; 
        end;
      end;
    end;
   // AddToSystemJournal('Container: ' + IntToStr(deeds_containers[i]) + '. Items: ' + IntToStr(cur) + '/' + IntToStr(max));
	if(cur < max) then begin
	  Result:=id;
	  EXIT;
	end;
    end;
  end;
  list.Free;
end;

procedure Sort(id:Cardinal);
var
BoxName:String;
boxID:Cardinal;
bodDef: TBODDef;
list, list2:TStringList;
minDeeds, minIndex, deeds, i: Integer;
str1: String;
id2: Cardinal;
begin
  bodDef := BuildBODDef(id);
  BoxName := GetTopBoxName(id);
  boxID := FindTopBox(BoxName+'_'+IntToStr(bodDef.Amt));
  if(boxID = 0) then begin
  UseObject(not_found_cont);
  Wait(350);
   if(FindType(book_id, not_found_cont) = 0) then begin  //No books, just dropping
    AddToSystemJournal('No books, just dropping;');
    MoveItem(id, 1, not_found_cont, 1, 1, 1);
  end else begin
  list := TStringList.Create;
    GetFindedList(list);
    minIndex := 0;
    id2 := StrToInt('$'+List[minIndex]);
    str1 := GetProperty(id2, TotalProperties(id2) - 1);
    list2 := TStringList.Create;
    StrBreakApart(str1, ':', list2);
    minDeeds := StrToInt(list2.Strings[1]);
    list2.Free;
    for i := 0 to List.Count - 1 do begin
      id2 := StrToInt('$'+List[i]);
      str1 := GetProperty(id2, TotalProperties(id2) - 1);
      list2 := TStringList.Create;
      StrBreakApart(str1, ':', list2);
      deeds := StrToInt(list2.Strings[1]);
      if(deeds = 0) then begin
        minDeeds := i;
      end else begin
        if(deeds < minDeeds) then begin
          minDeeds := deeds;
          minIndex := i;
        end;
      end;
      list2.Free;
    end;
    id2 :=  StrToInt('$'+List[minIndex]);
    MoveItem(id2, 1, Backpack, 1, 1, 1);
    Wait(350);
    MoveItem(id, 1, id2, 1, 1, 1);
    Wait(350);
    MoveItem(id2, 1, not_found_cont, 1, 1, 1);
    list.Free;
	EXIT;
    end;  
  end;
  if(GetDistance(boxID) >= 2) then begin
    MoveXY(GetX(boxID), GetY(boxID), true, 1, true);
  end;
  UseObject(boxID);
  Wait(250);
  if(bodDef.Exceptional) then begin
    boxID := FindBoxByName('exceptional', boxID);
  end else begin
    boxID := FindBoxByName('non exceptional', boxID);
  end;
  UseObject(boxID);
  Wait(250);
  boxID := FindResourceBox(GetResourceBoxName(bodDef.Res), boxID);
  UseObject(boxID);
  Wait(250);
  if(FindType(book_id, boxID) = 0) then begin  //No books, just dropping
    AddToSystemJournal('No books, just dropping;');
    MoveItem(id, 1, boxID, 1, 1, 1);
  end else begin
    AddToSystemJournal('Got some books, dropping to them;');
    list := TStringList.Create;
    GetFindedList(list);
    minIndex := 0;
    id2 := StrToInt('$'+List[minIndex]);
    str1 := GetProperty(id2, TotalProperties(id2) - 1);
    list2 := TStringList.Create;
    StrBreakApart(str1, ':', list2);
    minDeeds := StrToInt(list2.Strings[1]);
    list2.Free;
    for i := 0 to List.Count - 1 do begin
      id2 := StrToInt('$'+List[i]);
      str1 := GetProperty(id2, TotalProperties(id2) - 1);
      list2 := TStringList.Create;
      StrBreakApart(str1, ':', list2);
      deeds := StrToInt(list2.Strings[1]);
      if(deeds = 0) then begin
        minDeeds := i;
      end else begin
        if(deeds < minDeeds) then begin
          minDeeds := deeds;
          minIndex := i;
        end;
      end;
      list2.Free;
    end;
    id2 :=  StrToInt('$'+List[minIndex]);
    MoveItem(id2, 1, Backpack, 1, 1, 1);
    Wait(350);
    MoveItem(id, 1, id2, 1, 1, 1);
    Wait(350);
    MoveItem(id2, 1, boxID, 1, 1, 1);
    list.Free;
  end;
end;

procedure TrySort;
var
list, list2:TStringList;
cont,id:Cardinal;
j, i, deeds: Integer;
str1:String;
begin
  if(FindType(deed_id, Backpack) <> 0) then begin
    Sort(finditem);
  end else begin
    cont := GetReadyDeedsContainer();
    if(GetDistance(cont) > 2) then begin
      MoveXY(GetX(cont), GetY(cont), true, 1, true);
    end;
    UseObject(cont);
    Wait(350);
    if(FindType(book_id, cont) <> 0) then begin
	  List := TStringList.Create;
      GetFindedList(list);
      for i := 0 to List.Count - 1 do begin
        id := StrToInt('$'+List[i]);
        str1 := GetProperty(id, TotalProperties(id) - 1);
        list2 := TStringList.Create;
        StrBreakApart(str1, ':', list2);
        deeds := StrToInt(list2.Strings[1]);
        list2.Free;
        AddToSystemJournal('Book: ' + IntToStr(id) + '. Deeds: ' + IntToStr(deeds));
        if(deeds > 0) then begin
          MoveItem(id, 1, Backpack, 1,1,1);
          for j := 0 to bods_At_Once do begin
            Wait(500);
            UseObject(id);
            WaitForGump(bob_gump);
            ReplyGump(bob_gump, last_bod_btn);
          end;
          MoveItem(id, 1, cont, 1,1,1);
          break;
        end;
      end;
	  List.Free;
    end else begin
      AddToSystemJournal('No bulk order deeds book found!');
      for j := 0 to bods_At_Once do begin
        if(FindType(deed_id, cont) <> 0) then begin
          MoveItem(finditem, 1, Backpack, 1,1,1);
        end else begin
          AddToSystemJournal('No order deeds found!');
        end;
      end;
    end;
  end;
end;

function IsNumber(a:string):boolean;
begin
  Result := false;
  if((a='0')or(a='1')or(a='2')or(a='3')or(a='4')or(a='5')or(a='6')or(a='7')or(a='8')or(a='9')) then
  Result := true;
end;

procedure CheckConnection;
begin
  while not Connected do begin Connect; wait(10000); end;
end;

function HasProperty(item:Cardinal; prop: String):boolean;
var
tooltip: String;
i:Integer;
SL: TStringList;

begin
  SL := TStringList.Create;
  tooltip := GetTooltip(item);

  StrBreakApart(tooltip, '|', SL);
  Result := false;
  //AddToSystemJournal('Requested: ' + prop);
  //AddToSystemJournal('Tooltip: ' + tooltip);
  for i := 0 to Sl.Count -1 do begin
    //  AddToSystemJournal('prop: ' + Sl.Strings[i]);
    if(BMSearch(0, Sl.Strings[i], prop) <> 0) then begin
      Result := true;
      break;
    end;
  end;
  SL.Free;
end;

function GetProperty(item:Cardinal; prop: Integer):String;
var
tooltip: String;
SL: TStringList;
i:Integer;
begin
  SL := TStringList.Create;
  tooltip := GetTooltip(item);
  Result := '';
  StrBreakApart(tooltip, '|', SL);
  if((prop >= 0) and (prop <= Sl.Count - 1)) then
  Result := SL.Strings[prop];
  SL.Free;
end;

function TotalProperties(item:Cardinal):integer;
var
tooltip: String;
SL: TStringList;
i:Integer;
begin
  SL := TStringList.Create;
  tooltip := GetTooltip(item);
  StrBreakApart(tooltip, '|', SL);
  Result := Sl.Count;
  SL.Free;
end;

function GetPropertyByName(item:Cardinal; prop: String):String;
var
tooltip: String;
i:Integer;
SL: TStringList;
begin
  prop := LowerCase(prop);
  SL := TStringList.Create;
  tooltip := GetTooltip(item);
  Result := '';
  StrBreakApart(tooltip, '|', SL);
  //AddToSystemJournal('Searching: ' + prop);
  //AddToSystemJournal('Tooltip: ' + tooltip);
  for i := 0 to Sl.Count - 1 do begin
    //AddToSystemJournal('prop: ' +  Sl.Strings[i]);
    if(BMSearch(0, LowerCase(Sl.Strings[i]), prop) <> 0) then begin
      Result := Sl.Strings[i];
      break;
    end;
  end;
  SL.Free;
end;

function GetPropNameByStr(id:Cardinal;str:String): String;
var
list2: TStringList;
begin
  list2 := TStringList.Create;
  StrBreakApart(str, ':', list2);
  Result := list2.Strings[0];
  list2.Free;
end;

function GetPropByStr(id:Cardinal;str:String): Integer;
var
list2: TStringList;
begin
  list2 := TStringList.Create;
  StrBreakApart(str, ':', list2);
  // AddToSystemJournal('Prop to split: ' + str);
  Result := StrToInt(list2.Strings[1]);
  list2.Free;
end;

function BuildBODDef(id:Cardinal): TBODDef;
var
str: String;
list: TStringList;
begin
  AddToSystemJournal('---[BOD Info] ');
  Result.Amt := GetPropByStr(id, GetPropertyByName(id, 'amount to make:'));
  AddToSystemJournal('Amount: ' + IntToStr(Result.Amt));
  if(HasProperty(id, 'All items must be exceptional.')) then begin
    Result.Exceptional := true;
    AddToSystemJournal('Exceptional: yes');
  end else begin
    AddToSystemJournal('Exceptional: no');
    Result.Exceptional := false;
  end;
  if(HasProperty(id, 'All items must be made with')) then begin
    str := GetPropertyByName(id, 'All items must be made with');
    list := TStringList.Create;
    StrBreakApart(str, 'All items must be made with', list);
    str := list.Strings[1];
    list.Free;
    AddToSystemJournal('Resource: ' + str);
    Result.Res := LowerCase(str);
  end else begin
    Result.Res := 'default';
  end;
  AddToSystemJournal('---[BOD Info End]');
end;

procedure LoadBODColors;
var
list, list2: TStringList;
i: Integer;
s: String;
begin
  list := TStringList.Create;
  list.LoadFromFile(GetCurrentDir() + '/Scripts/BODSorter/types.txt');
  for i := 0 to list.COunt - 1 do begin
    begin
      s:=list.Strings[i];
      if(s[1] <> '#') then begin
        list2 := TStringList.Create;
        SetLength(ColorDefs, Length(ColorDefs) + 1);
        StrBreakApart(s, ',', list2);
        ColorDefs[Length(ColorDefs) - 1].Hue := StrToInt(list2.Strings[0]);
        ColorDefs[Length(ColorDefs) - 1].BoxName := list2.Strings[1];
        list2.Free;
      end;
    end;
  end;
  list.Free;
  AddToSystemJournal('Loaded ' + IntToStr(Length(ColorDefs)) + ' bod entries;');
end;

procedure LoadResNames;
var
list, list2: TStringList;
i: Integer;
s: String;
begin
  list := TStringList.Create;
  list.LoadFromFile(GetCurrentDir() + '/Scripts/BODSorter/resources.txt');
  for i := 0 to list.COunt - 1 do begin
    begin
      s:=list.Strings[i];
      if(s[1] <> '#') then begin
        list2 := TStringList.Create;
        SetLength(ResDefs, Length(ResDefs) + 1);
        StrBreakApart(s, ',', list2);
        ResDefs[Length(ResDefs) - 1].ResName := LowerCase(list2.Strings[0]);
        ResDefs[Length(ResDefs) - 1].BoxName := list2.Strings[1];
        list2.Free;
      end;
    end;
  end;
  list.Free;
  AddToSystemJournal('Loaded ' + IntToStr(Length(ResDefs)) + ' resource entries;');
end;

procedure RemoveOldSaveMessages;
var
pos, savePos: Integer;
begin
  savePos := InJournal('World save complete. The entire process took');
  pos := InJournal('The world will save in');
  while((pos <> -1) and (pos < savePos)) do begin
    SetJournalLine(pos, '');
    pos := InJournal('The world will save in');
  end;
end;

procedure WaitSave;
begin
  if(InJournal('The world will save in') <> -1) then begin
    AddToSystemJournal('Waiting for save;');
    Wait(saveTime * 1000);
    RemoveOldSaveMessages;
  end;
end;

procedure LoadConfig;
var
list, list2:TStringList;
i, j:Integer;
str, val:String;
begin
  list := TStringList.Create;
  list.LoadFromFile(GetCurrentDir() + '/Scripts/BODSorter/'+ProfileName+'_BODSorter_Config.txt');
  for i := 0 to list.Count - 1 do begin
    list2 := TStringList.Create;
    StrBreakApart(list[i], '=', list2);
    str := list2[0];
    val := list2[1];
    list2.Free;
    if(str = 'bods_At_Once') then begin
      bods_At_Once := StrToInt(val);
    end else if(str = 'top_box_id') then begin
      top_box_id  := StrToInt(val);
    end else if(str = 'except_box_id') then begin
      except_box_id  := StrToInt(val);
    end else if(str = 'resource_box_id') then begin
      resource_box_id  := StrToInt(val);
    end else if(str = 'saveTime') then begin
      saveTime  := StrToInt(val);
    end else if(str = 'not_found_cont') then begin
      not_found_cont  := StrToInt(val);
    end;

    if((str = 'ready_deeds_containers') and (val = '[')) then begin
      for j := i + 1 to list.Count - 1 do begin
        inc(i);
        val := Trim(list[j]);
        if(val <> ']') then begin
          SetLength(ready_deeds_containers, Length(ready_deeds_containers) + 1);
          ready_deeds_containers[Length(ready_deeds_containers) - 1] := StrToInt(val);
        end else begin
          BREAK;
        end;
      end;
    end;
  end;
  list.Free;
  AddToSystemJournal('bods_At_Once: ' + IntTOStr(bods_At_Once));
  AddToSystemJournal('top_box_id: ' + IntTOStr(top_box_id));
  AddToSystemJournal('except_box_id: ' + IntTOStr(except_box_id));
  AddToSystemJournal('resource_box_id: ' + IntTOStr(resource_box_id));
  AddToSystemJournal('saveTime: ' + IntTOStr(saveTime));
  AddToSystemJournal('not_found_cont: ' + IntTOStr(not_found_cont));
  
  AddToSystemJournal('ready_deeds_containers: ');
  for i := 0 to Length(ready_deeds_containers) - 1 do begin
    AddToSystemJournal(IntToStr(ready_deeds_containers[i]));
  end;
end;

begin
	SetLength(ResDefs, Length(ResDefs) + 1);
    ResDefs[Length(ResDefs) - 1].ResName := 'default';
    ResDefs[Length(ResDefs) - 1].BoxName := 'default';
End.